"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.runWithinCli = void 0;
const config_1 = require("./config");
const db_1 = require("./db");
const yargs_1 = __importDefault(require("yargs/yargs"));
const chalk_1 = __importDefault(require("chalk"));
function runWithinCli(fn, configRootDir) {
    return __awaiter(this, void 0, void 0, function* () {
        const args = yargs_1.default(process.argv).argv;
        if (!process.env.NODE_ENV && typeof args.env === "string") {
            process.env.NODE_ENV = args.env;
        }
        if (!process.env.NODE_ENV) {
            throw new Error(`The environment variable ${chalk_1.default.red("process.env.NODE_ENV")} must be set`);
        }
        yield config_1.loadConfig(configRootDir);
        const mongodbUriInfo = config_1.getConfig("mongodbConnectOption");
        if (mongodbUriInfo) {
            yield db_1.connectMongodb(mongodbUriInfo);
        }
        yield (fn === null || fn === void 0 ? void 0 : fn());
        if (mongodbUriInfo) {
            yield db_1.disconnectMongodb();
        }
        process.exit();
    });
}
exports.runWithinCli = runWithinCli;
