import { MongodbConnectOption } from "./db";
export interface ConfigOption {
    debug: boolean;
    httpHost?: string;
    httpPort?: number | string;
    postBodyLimit?: number;
    controllerRootDir: string;
    onBeforeActionHook?: string;
    onAfterActionHook?: string;
    mongodbConnectOption?: MongodbConnectOption;
}
export declare let configData: Partial<ConfigOption>;
export declare function loadConfig(configRootDir?: string): Promise<void>;
export declare function getConfig<T = undefined>(key: keyof ConfigOption, value?: T): T | undefined;
export declare function setConfig<T>(key: string, value: T): void;
