"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.setConfig = exports.getConfig = exports.loadConfig = exports.configData = void 0;
const path_1 = __importDefault(require("path"));
exports.configData = {
    httpHost: "127.0.0.1",
    httpPort: 9000,
    debug: false,
    postBodyLimit: 1024 * 1024 * 8,
    onBeforeActionHook: "onBeforeActionCall",
    onAfterActionHook: "onAfterActionCall",
};
function loadConfig(configRootDir) {
    return __awaiter(this, void 0, void 0, function* () {
        if (!configRootDir) {
            configRootDir = path_1.default.resolve(process.cwd(), "./config");
        }
        const mainConfigFile = path_1.default.resolve(configRootDir, "./main.js");
        const mainConfig = (yield Promise.resolve().then(() => __importStar(require(mainConfigFile))))
            .default;
        exports.configData = Object.assign(Object.assign({}, exports.configData), mainConfig);
        if (process.env.NODE_ENV) {
            const envConfigFile = path_1.default.resolve(configRootDir, `./${process.env.NODE_ENV}.js`);
            try {
                const envConfig = (yield Promise.resolve().then(() => __importStar(require(envConfigFile)))).default;
                exports.configData = Object.assign(Object.assign({}, exports.configData), envConfig);
            }
            catch (error) { }
        }
        if (!exports.configData.controllerRootDir) {
            throw new Error(`The controller root directory must be developed`);
        }
    });
}
exports.loadConfig = loadConfig;
function getConfig(key, value) {
    if (!key || typeof key !== "string" || exports.configData[key] === undefined) {
        return value;
    }
    return exports.configData[key];
}
exports.getConfig = getConfig;
function setConfig(key, value) {
    exports.configData[key] = value;
}
exports.setConfig = setConfig;
