import mongoose from "mongoose";
export interface MongodbConnectOption {
    host?: string;
    port?: string | number;
    database?: string;
    user?: string;
    password?: string;
    debug?: boolean;
}
export declare function createConnectionURI(option?: MongodbConnectOption): string;
export declare function connectMongodb(option?: MongodbConnectOption): Promise<void>;
export declare function disconnectMongodb(): Promise<void>;
export declare function createMongooseModel(name: string, definition: mongoose.SchemaDefinition, option?: mongoose.SchemaOptions): {
    schema: mongoose.Schema<mongoose.Document<any>, mongoose.Model<mongoose.Document<any>>>;
    model: mongoose.Model<mongoose.Document<any>>;
};
